﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace Slider_ValueInAPopup
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		Thumb valueThumb;
		TextBlock textBlock;
		Popup popup;
		Border border;

		public MainWindow()
		{
			InitializeComponent();

			border = new Border()
			{
				BorderThickness = new Thickness(1),
				BorderBrush = Brushes.Black,
				Background = Brushes.White,
				Margin = new Thickness(0,0,0,0),
			};
			
			textBlock = new TextBlock() 
			{ 
				Height = 20,
				Text = xSlider.Value.ToString(),
				Margin = new Thickness(4, 0, 4, 0),
				VerticalAlignment=System.Windows.VerticalAlignment.Center,
				HorizontalAlignment=System.Windows.HorizontalAlignment.Center 
			};

			border.Child = this.textBlock;
		}

		private void RadSlider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
		{
			if (textBlock != null && popup != null)
			{
				var offset = popup.HorizontalOffset;
				popup.HorizontalOffset = offset - 1;
				popup.HorizontalOffset = offset;

				var value = Math.Round(e.NewValue);
				textBlock.Text = value.ToString();
			}
		}

		private void xSlider_Loaded(object sender, RoutedEventArgs e)
		{
			valueThumb = this.xSlider.ChildrenOfType<FrameworkElement>().Where(x => x.Name == "SingleThumbHost").FirstOrDefault() as Thumb;
			if (valueThumb != null)
			{
				valueThumb.DragCompleted += valueThumb_DragCompleted;
				valueThumb.DragStarted += valueThumb_DragStarted;
				this.CreatePopUpControl();
			}
		}

		void valueThumb_DragStarted(object sender, DragStartedEventArgs e)
		{			
			popup.IsOpen = true;
		}

		void valueThumb_DragCompleted(object sender, DragCompletedEventArgs e)
		{
			popup.IsOpen = false;
		}

		private void CreatePopUpControl()
		{
			popup = new Popup();
			popup.PlacementTarget = this.valueThumb;
			popup.AllowsTransparency = true;
			popup.Placement = System.Windows.Controls.Primitives.PlacementMode.Top;
			popup.Child = border;
			popup.HorizontalOffset = popup.HorizontalOffset - 4;
		}
	}
}
